routes/web.php
<?php

use Illuminate\Support\Facades\Route;
/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/','IndexController@index');
Route::get('about', 'IndexController@about');
Route::get('contact', 'IndexController@contact');
Route::get('work','IndexController@work');
Route::get('/details/{id}','IndexController@details');
Route::get('posts/show-work/{id}','IndexController@showWork');
Route::get('search','IndexController@search');
Route::get('/send-mail', 'MailController@sendEmail');

Route::get('lang/{locale}', 'LocalizationController@index');
Auth::routes(['register' => false]);

Route::get('/home', 'HomeController@index')->name('home');

Route::resource('post-types','PostTypeController');
Route::resource('posts','PostController');
Route::delete('posts/delete-image/{id}','PostController@deleteImage');
Route::resource('users','UserController');
Route::get('users/edit-password/{id}','UserController@editPassword');
Route::post('users/change-password/{id}','UserController@changePassword');
Route::resource('slide-images','SlideImagesController');

app/Post.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use App\Http\Traits\Uuids;
use App\Attachment;

class Post extends Model
{
    use Uuids;
    protected $keyType = 'string';
    public $incrementing = false;
    protected $guarded = [];

    protected $table = 'posts';

    protected $fillable = ['post_type_id','thumbnail','title_kh','title_en','content_en','content_kh','is_published','activate_code','created_by','updated_by'];

    public function post_type()
    {
        return $this->belongsTo('App\PostType','post_type_id');
    }

    public function creator()
    {
        return $this->belongsTo('App\User','created_by');
    }

    public function updator()
    {
        return $this->belongsTo('App\User','updated_by');
    }

    public function thumbnail($postId)
    {
        return Attachment::where(['post_id' => $postId,'name'=>'thumbnails'])->pluck('path');
    }

    public function images($postId)
    {
        return Attachment::where(['post_id' => $postId,'name'=>'posts'])->orderBy('size','desc')->get(); 
    }
}

app/PostType.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use App\Http\Traits\Uuids;

class PostType extends Model
{
    use Uuids;
    protected $keyType = 'string';
    public $incrementing = false;
    protected $guarded = [];

    protected $table = 'post_types';

    protected $fillable = ['post_type_en','post_type_kh','description_en','description_kh','is_public','created_by','updated_by'];

    public function creator()
    {
        return $this->belongsTo('App\User','created_by');
    }

    public function updator()
    {
        return $this->belongsTo('App\User','updated_by');
    }
}

app/Http/Controllers/PostController.php
<?php

namespace App\Http\Controllers;

use Auth;
use App\Post;
use App\PostType;
use App\Attachment;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Storage;
use Image;

class PostController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $collection = Post::get();
        return view('posts.index',['collection' => $collection]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $postype = PostType::where('is_published',1)->get();
        return view('posts.create',['postype'=>$postype]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        request()->validate([
            'title_en' => 'required',
            'title_kh' => 'required',
            'content_en' => 'required',
            'content_kh' => 'required',
            'post_type' => 'required',
            'status' => 'required',
            'thumbnail'  =>  'required',
            'thumbnail.*' => 'mimes:jpg,jpeg,png,gif',
            'filenames' => 'required',
            'filenames.*' => 'mimes:jpg,jpeg,png,gif',
        ]);    

        $message=$request->content_en;

        $dom = new \DomDocument();
        $dom->loadHtml('<?xml encoding="UTF-8">'.$message);   
        $images = $dom->getElementsByTagName('img');

        foreach($images as $img){
            $src = $img->getAttribute('src');            
            // if the img source is 'data-url'
            if (preg_match("'/data:image/'", $src)) {
                preg_match("'/data:image\/(?<mime>.*?)\;/'", $src, $groups);
                $mimeType = $groups['mime'];
                $path = "'/images/'" . uniqid('', true) . '.' . $mimeType;
                Storage::disk('public')->put($path, file_get_contents($src));
                $image->removeAttribute('src');
                $image->setAttribute('src', Storage::disk('public')->url($path));
            }
        }
        $body_en = $dom->saveHTML();


        $message_kh=$request->content_kh;
        $dom_kh = new \DomDocument();
        $dom_kh->loadHtml('<?xml encoding="UTF-8">'.$message_kh);   
        $images_kh = $dom_kh->getElementsByTagName('img');

        foreach($images_kh as $img){
            $src = $img->getAttribute('src');            
            // if the img source is 'data-url'
            if (preg_match("'/data:image/'", $src)) {
                preg_match("'/data:image\/(?<mime>.*?)\;/'", $src, $groups);
                $mimeType = $groups['mime'];
                $path = "'/images/'" . uniqid('', true) . '.' . $mimeType;
                Storage::disk('public')->put($path, file_get_contents($src));
                $image->removeAttribute('src');
                $image->setAttribute('src', Storage::disk('public')->url($path));
            }
        }

        $body_kh = $dom_kh->saveHTML();
        
        $post = Post::create([
            'post_type_id' => $request->post_type,
            'thumbnail' => '',
            'title_en' => $request->title_en,
            'content_en' =>  $body_en,
            'title_kh' => $request->title_kh,
            'content_kh' =>  $body_kh,
            'activate_code' => $request->activate_code,
            'is_published' => $request->status,
            'created_by' => Auth::User()->id,
            'updated_by' => Auth::User()->id,
        ]);
        
        if($imageFiles = $request->file('thumbnail')){
                $name = $imageFiles->getClientOriginalName();
                $mimetype = number_format($imageFiles->getSize()/1048576,3).' MB'; 
                $path = $imageFiles->storeAs('public/thumbnails', $name);
                if($path) {
                    $save   =   Attachment::create([
                    'post_id' => $post->id,
                    'name' => 'thumbnails',
                    'path' => $path,
                    'size' => $mimetype
                    ]);
                }
            }

        if($request->hasfile('filenames'))
         {
            foreach($request->file('filenames') as $file)
            {
                $name = $file->getClientOriginalName();
                $mimetype = number_format($file->getSize()/1048576,3).' MB'; 
                $path = $file->storeAs('public/posts', $name);
                if($path) {
                    $save   =   Attachment::create([
                    'post_id' => $post->id,
                    'name' => 'posts',
                    'path' => $path,
                    'size' => $mimetype
                    ]);
                }
            }
         }

        return redirect()->route('posts.index')
                        ->with('success','Post has been created successfully.');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Post  $post
     * @return \Illuminate\Http\Response
     */
    public function show(Post $post)
    {
        $post = Post::find($post->id);
        $attachemnts = Attachment::where('post_id',$post->id)->get();
        $postype = PostType::get();
        return view('posts.show',['post' => $post,'attachemnts' => $attachemnts, 'postype' => $postype]);
    }
    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Post  $post
     * @return \Illuminate\Http\Response
     */
    public function edit(Post $post)
    {
        $post = Post::find($post->id);
        $collection = PostType::where('is_public',1)->get();
        return view('posts.edit',['post' => $post,'collection' => $collection]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Post  $post
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {$message=$request->content_en;

        $dom = new \DomDocument();
        $dom->loadHtml('<?xml encoding="UTF-8">'.$message);   
        $images = $dom->getElementsByTagName('img');

        foreach($images as $img){
            $src = $img->getAttribute('src');            
            // if the img source is 'data-url'
            if (preg_match("'/data:image/'", $src)) {
                preg_match("'/data:image\/(?<mime>.*?)\;/'", $src, $groups);
                $mimeType = $groups['mime'];
                $path = "'/images/'" . uniqid('', true) . '.' . $mimeType;
                Storage::disk('public')->put($path, file_get_contents($src));
                $image->removeAttribute('src');
                $image->setAttribute('src', Storage::disk('public')->url($path));
            }
        }
        $body_en = $dom->saveHTML();


        $message_kh=$request->content_kh;
        $dom_kh = new \DomDocument();
        $dom_kh->loadHtml('<?xml encoding="UTF-8">'.$message_kh);   
        $images_kh = $dom_kh->getElementsByTagName('img');

        foreach($images_kh as $img){
            $src = $img->getAttribute('src');            
            // if the img source is 'data-url'
            if (preg_match("'/data:image/'", $src)) {
                preg_match("'/data:image\/(?<mime>.*?)\;/'", $src, $groups);
                $mimeType = $groups['mime'];
                $path = "'/images/'" . uniqid('', true) . '.' . $mimeType;
                Storage::disk('public')->put($path, file_get_contents($src));
                $image->removeAttribute('src');
                $image->setAttribute('src', Storage::disk('public')->url($path));
            }
        }

        $body_kh = $dom_kh->saveHTML();
        

        $post = Post::find($id);
        $post->post_type_id = $request->postType;
        $post->title_en = $request->title_en;
        $post->title_kh = $request->title_kh;
        $post->content_en = $body_en;
        $post->content_kh = $body_kh;
        $post->activate_code = $request->activate_code;
        $post->is_published = $request->status;
        $post->updated_by = Auth::User()->id;
        $post->save();

        $attachemnts = Attachment::where(['name'=>'thumbnails','post_id'=> $id])->first();
        if($imageFiles = $request->file('thumbnail')){
                $name = $imageFiles->getClientOriginalName();
                $mimetype = number_format($imageFiles->getSize()/1048576,3).' MB'; 
                $path = $imageFiles->storeAs('public/thumbnails', $name);
                if($attachemnts->path){
                    $this->deleteFile($attachemnts->path);
                }
                    Attachment::create([
                    'post_id' => $post->id,
                    'name' => 'thumbnails',
                    'path' => $path,
                    'size' => $mimetype
                    ]);
            }

        $attachemnts = Attachment::where(['name' => 'posts','post_id' => $id])->get();
        if($request->hasfile('filenames'))
         {
            foreach($request->file('filenames') as $file)
            {
                $name = $file->getClientOriginalName();
                $mimetype = number_format($file->getSize()/1048576,3).' MB'; 
                $path = $file->storeAs('public/posts', $name);
                Attachment::create([
                    'post_id' => $post->id,
                    'name' => 'posts',
                    'path' => $path,
                    'size' => $mimetype
                ]);
            }
         }
        
        return redirect()->route('posts.index')
                        ->with('success','Post has been created successfully.');
    }

    /**
     * Remove the specified resource from storage.
     *

resources/views/posts/create.blade.php
@extends('layouts.app')
@section('css')
    <style>
        .float-right {
            margin-top: -40px;
        }

        #preview {
            max-height: 180px;
            height: auto;
            width: 300px;
            display: block;
            margin-left: auto;
            margin-right: auto;
            padding: 5px;
        }

        #img_container {
            border-radius: 5px;
            margin-top: 3px;
            margin-bottom: 3px;
            width: auto;
        }

        .imgInp {
            display: none;
            margin-top: 10px;
            padding: 10px;
        }

        .addImg {
            display: none;
            margin-top: 10px;
            padding: 10px;
        }

        @keyframes blinkingText {
            0% {
                color: #000;
            }

            50% {
                color: #transparent;
            }

            99% {
                color: transparent;
            }

            100% {
                color: #000;
            }
        }

        .custom-file-label {
            cursor: pointer;
        }

        .c-input-h {
            height: 38px;
        }

        .clone {
            display: none;
        }

        .photo-thumbnail {
            width: 220px;
            height: 120px;
            border-radius: 4px;
            margin-right: 5px;
        }

        .remove-img {
            display: none;
            margin-top: -120px;
            position: relative;
            margin-right: 48px;
            padding: 5px 15px 5px 15px;
        }

        .image-answer:hover .remove-img{
            display: block;
        }

    </style>
@endsection
@section('content')
    <div class="page-title">
        <div class="row">
            <div class="col-12 col-md-6 order-md-1 order-last">
                <h3>Post</h3>
                <p class="text-subtitle text-muted">User can create your post by below.</p>
            </div>
            <div class="col-12 col-md-6 order-md-2 order-first">
                <nav aria-label="breadcrumb" class='breadcrumb-header'>
                    <ol class="breadcrumb">
                        <li class="breadcrumb-item"><a href="{{ route('posts.index') }}">Posts</a></li>
                        <li class="breadcrumb-item"><a href="{{ route('posts.index') }}">Posts List</a></li>
                        <li class="breadcrumb-item active" aria-current="page">Posts</li>
                    </ol>
                </nav>
            </div>
        </div>
    </div>
    <section class="section">
        <div class="col-md-12">
            <div class="card">
                <form action="{{ route('posts.store') }}" method="post" enctype="multipart/form-data" id="form1">
                    @csrf
                    <div class="card-header">
                        <h4 class="card-title">Post</h4>
                        <div class="float-right">
                            <a href="{{ route('posts.index') }}" class="btn btn-danger"><i data-feather="x"></i> Close</a>
                            <button type="submit" class="btn btn-primary save-button"><i data-feather="save"></i>
                                Save</button>
                        </div>
                    </div>
                    <div class="card-body">
                        <div class="row">
                            <div class="col-md-6">
                                <div class="form-group">
                                    <label for="basicInput">Title (AS ENGLISH)</label>
                                    <input type="text" class="form-control" name="title_en" placeholder="Enter title"
                                        value="">
                                    <p><small class="text-red">{{ $errors->first('title_en') }}</small></p>
                                </div>
                                <div class="form-group">
                                    <label for="helperText">THUMBNAIL [SIZE: 300PX X 300PX]</label>
                                    <div id='img_container'>
                                        <img id="preview" src="{{ asset('img/placeholder.png') }}" alt="your image"
                                            title='' />
                                    </div>
                                    <div class="input-group">
                                        <input type="file" id="inputGroupFile01" name="thumbnail"
                                            class="imgInp custom-file-input" aria-describedby="inputGroupFileAddon01"
                                            accept="image/*" value="">
                                        <label class="form-control custom-file-label"
                                            for="inputGroupFile01">Thumbnail</label>
                                        <button class="btn btn-primary" type="button" id="chooseThumbnail">Choose
                                            Thumbnail</button>
                                    </div>
                                    <p><small class="text-red">{{ $errors->first('thumbnail') }}</small></p>
                                </div>
                                <div class="form-group" style="margin-top: -6px !important;">
                                    <label for="exampleFormControlTextarea1" class="form-label">CONTENT (AS English)</label>
                                    <textarea class="form-control summernote_en" name="content_en" rows="3"></textarea>
                                    <p><small class="text-red">{{ $errors->first('content_en') }}</small></p>
                                </div>
                            </div>
                            <div class="col-md-6">
                                <div class="form-group">
                                    <label for="basicInput">Title (AS KHMER)</label>
                                    <input type="text" class="form-control" name="title_kh" placeholder="Enter title"
                                        value="">
                                    <p><small class="text-red">{{ $errors->first('title_kh') }}</small></p>
                                </div>
                                <div class="form-group">
                                    <label for="helperText">Post Type</label>
                                    <div class="">
                                        <select class="choices form-select postType" id="postType" name="post_type">
                                            @foreach ($postype as $item)
                                                <option value="{{ $item->id }}">{{ $item->post_type_en }} |
                                                    {{ $item->post_type_kh }}
                                                </option>
                                            @endforeach
                                        </select>
                                    </div>
                                    <p><small class="text-red">{{ $errors->first('post_type') }}</small></p>
                                </div>
                                <br><br>
                                <div class="form-group">
                                    <label for="helperText">Status</label>
                                    <div class="form-group">
                                        <select class="choices form-select status" id="status" name="status">
                                            <option value="0">Draft</option>
                                            <option value="1">Published</option>
                                        </select>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label for="basicInput">Generate Activate code</label>
                                    <div class="input-group input-group-sm">
                                        <input type="text" name="activate_code"
                                            class="form-control form-control-sm activate-code-input" placeholder="xxxxxx"
                                            aria-label="Example text with button addon" aria-describedby="button-addon1">
                                        <button class="btn btn-primary activate-code" type="button"
                                            id="button-addon1">Generate</button>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label for="exampleFormControlTextarea1" class="form-label">CONTENT (AS KHMER)</label>
                                    <textarea class="form-control summernote_kh" name="content_kh"
                                        id="exampleFormControlTextarea1" rows="3"></textarea>
                                    <p><small class="text-red">{{ $errors->first('content_kh') }}</small></p>
                                </div>
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="basicInput">Add New Images <button type="button" class="btn btn-primary"
                                    id="add_more">Add Image</button></label>
                            <br>
                            <label for="" class=" text-truncate">Big size 1140px x 700px</label><br>
                            <label for="">Medium size 552px x 400px</label><br>
                            <label for="">Small size 370px x 300px</label>
                            <hr>
                            <div class="row add-rows"></div>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </section>
@endsection
@section('js')
    <script type="text/javascript">
        $(document).ready(function() {

            $('.activate-code').click(function() {
                var a = Math.floor(100000 + Math.random() * 900000);
                a = String(a);
                a = a.substring(0, 6);
                $('.activate-code-input').val(a);
            })

            $("#inputGroupFile01").change(function(event) {
                readURL(this);
            });

            function readURL(input) {
                if (input.files && input.files[0]) {
                    var reader = new FileReader();
                    var filename = $("#inputGroupFile01").val();
                    filename = filename.substring(filename.lastIndexOf('\\') + 1);
                    reader.onload = function(e) {
                        debugger;
                        $('#preview').attr('src', e.target.result);
                        $('#preview').hide();
                        $('#preview').fadeIn(500);
                        $('.custom-file-label').text(filename);
                    }
                    reader.readAsDataURL(input.files[0]);
                }
            }

            var counter = 0;
            //Add more
            $('#add_more').click(function(e) {
                //add new answer
                counter++; //increare counter
                var newRow = '<div class="col-lg-3 col-md-4 col-sm-6 image-answer mb-4">' +
                    '<div class="">' +
                    '<input type="image" class="add_image photo-thumbnail" src="{{ asset('img/placeholder.png') }}">'+
                    '<input type="file" class="select_file" accept="image/*" name="filenames[]" id="file-0"style="display: none;">' +
                    '<button class="btn btn-danger remove-img remove_answer float-right" type="button"><iclass="fldemo glyphicon glyphicon-remove"></iclass=>Remove Image</button>' +
                    '</div>' +
                    '</div>';
                //append new answers
                $('.add-rows').append(newRow);
            })

            //remove answer
            $(document).on('click', '.remove_answer', function() {
                //remove the answer div
                $(this).parent().parent().remove()
                counter-- //decrease counter
            })

            //Load preview image on each answer
            $(document).on('click', '.add_image', function(e) {
                e.preventDefault()
                //add file to input / trigger click
                $(this).next('input').click();
            })

            //Watch the change on select file
            $(document).on('change', '.select_file', function(e) {

                e.preventDefault()
                //get the sibling img src of the change file
                var prevInput = $(this).prev('input')
                //Call read file preview
                previewFile(this, prevInput);
                
            });

            //Preview img
            function previewFile(input, previewSrc) {
                if (input.files && input.files[0]) {
                    var reader = new FileReader();
                    reader.onload = function(e) {
                        //load file into actual preview img
                        $(previewSrc).attr('src', e.target.result);
                    }
                    reader.readAsDataURL(input.files[0]); // convert to base64 string
                }
            }

        });

    </script>
@endsection

resources/views/posts/show_work.blade.php
@extends('layouts.app_front')
@section('content')
    {{-- <section class="breadcrumbs">
        <div class="container">
            <div class="d-flex justify-content-between align-items-center">
                <h2>{{ __('app.portfolioPage') }}</h2>
            </div>
        </div>
    </section> --}}
    <section class="portfolio-details">
        <div class="container">
            <div class="portfolio-description">
                <h2>{{ Session::get('locale') == 'kh' ? $posts->title_kh : $posts->title_en }}</h2>
                <p>{!! Session::get('locale') == 'kh' ? $posts->content_kh : $posts->content_en !!}</p>
            </div>
        </div>
        <div class="container">
            @foreach ($posts->images($posts->id) as $i => $item)
                <img src="{{ Storage::url($item->path) }}" class="img-fluid mb-4" alt="">
            @endforeach
        </div>
    </section>
    </main>
@endsection